#include "extern.h"

/* Query and access functions
   This function return information about distributed arrays
   Basicly, How a distributed array looks in node program
*/



/*  rank of a */
int arank(a)
char *a;
{
  T_Entry *entry;
  
  entry = lookup_loc(a);
  return entry->local_shape->rank;
}

/* lower bound of the k-th dimension of a */
Node *alow(a,k)
char *a;
int k;
{

  T_Entry *entry;
  
  entry = lookup_loc(a);
  return entry->local_shape->sizes0[k];
}

/* upper bound of the k-th dimension of a */
Node *ahigh(a,k)
char *a;
int k;
{

  T_Entry *entry;
  
  entry = lookup_loc(a);
  return entry->local_shape->sizes1[k];
}

/* size  of the k-th dimension of a */
Node *aextent(a,k)
char *a;
int k;
{

  T_Entry *entry;
  
  entry = lookup_loc(a);
  return entry->local_shape->sizes2[k];
}

/* 
   returns the dimension of TEMPLATE which a is aligned at k dimension
   For example 
   distr_dim[0] == -1 is not distributed at first dim
   distr_dim[1] == 0 is distributed according to template first dim */

int pdim(a,k)
char *a;
int k;
{
  T_Entry *entry;
  
  entry = lookup_loc(a);
  return entry->local_shape->distr_dim[k];
}

/* distribution typ in the k-th dimention of a
   it reruns 1 for BLOCK
             2 for CYCLIC
             0 none
*/
int pdist(a,k)
char *a;
int k;
{
  T_Entry *entry;
  int tdim;

  tdim=pdim(a,k);
  if(tdim ==-1) return 0;
  else {
        entry = lookup_loc(a);
        return entry->align_template->dist_style[tdim];
      }
}

